<?
# Spaghetti on Snails.
# A lightweight web framework. 
# Greg Retkowski <greg@rage.net>
# Licensed under the LGPL
#


# Load PEAR DB_DataObject.
require_once 'DB/DataObject.php';
require_once 'DB/DataObject/Generator.php';
$config = parse_ini_file('db/database.ini',TRUE);
foreach($config as $class=>$values) {
    $options = &PEAR::getStaticProperty($class,'options');
    $options = $values;
}

#
# Framework Creation
#
# Setup the app if called on the command line.
#
if ( ! $_SERVER['PHP_SELF'] ) {
    # Re-Generate DB Schema
    echo "Run from command line, updating environment!\n";
    @mkdir("db");
    @mkdir("db/dataobjects");
    @mkdir("views");
    @mkdir("css");
    @mkdir("images");
    @mkdir("helpers");
    if(! file_exists("db/database.ini") ) {
        $f = fopen("db/database.ini");
        $inifile="
[DB_DataObject]
database         = mysql://root:@localhost/database_name_here
schema_location  = db/dataobjects/schema/
class_location   = db/dataobjects/
require_prefix   = db/dataobjects/
class_prefix     = DataObjects_
extends_location = DB/DataObject.php
extends          = DB_DataObject
";
        fwrite($f,$inifile);
        fclose($f);
        echo "New database.ini created. Edit db/database.ini to suit.";
    }
    if ( ! file_exists("index.html")) {
        $f = fopen("index.html","w");
        $in='<meta http-equiv="refresh" content="0;url=sos.php">';
        fwrite($f,$in);
        fclose($f);
    }
    $generator = new DB_DataObject_Generator;
    $generator->start();
    exit;

}


# Figure out where the top of the application is
$z = split(basename(__FILE__),$_SERVER['PHP_SELF']);
list($junk,$class,$func,$args) = split("/",$z[1]);
$apptop = $z[0].basename(__FILE__);
$topdir = $z[0];

# Our 'view' - a template.
class View {
    var $name;
    var $wrapper;
    var $inner;
    var $topdir;
    function View($name,$wrapper) {
        $this->name = $name;
        $this->wrapper = $wrapper;
        global $topdir;
        $this->topdir = $topdir;
        global $apptop;
        $this->apptop = $apptop;


    }
    function render() {
        if($this->wrapper) {
             $this->inner = "views/".$this->name.".t.php";
             include("views/".$this->wrapper.".w.php");
        } else {
            include("views/".$this->name.".t.php");
        }
    }
}
# Right now just a nice alias. More code here in the future.
class Model extends DB_DataObject {
}
class Controller {
    var $apptop;
    function Controller() {
        global $apptop;
        $this->apptop = $apptop;
    }
    # We can put defaults for views, data whatever here.
    function create() {
    }
    function retrieve() {
    }
    function update() {
    }
    function destroy() {
    }
    function link($link,$title) {
        return("<a href=".$this->apptop."/".$link.">".$title."</a>");

    }
}

#
# ROUTING CODE: convert /class/function to something we run!
#

# Set the default class and function.
$class = preg_replace('/[^a-zA-Z0-9_]/i','',$class);
$func = preg_replace('/[^a-zA-Z0-9_]/i','',$func);
if (!$class) {
    $class = "top";
}
if (!$func) {
    $func = "index";
}
# Load all helpers here.
$h = opendir("helpers");
while (false !== ($file = readdir($h))) {
    include("helpers/".$file);
}
# We're done setting up. Invoke the called class & function.
include($class.".php");
$obj = new $class;
$obj->$func($args);
?>
